@import {"gplayer.ck", "raycaster.ck"};
@import "constants.ck";

public class GObstacle extends GGen
{
    Constants c;

    // floor
    // GPlane floor --> this;
    // floor.rotateX(Math.PI/2);
    GCube @ obstacle;

    // player and raycaster
    GPlayer @ player;
    RayCaster @ rc;

    // state of obstacle
    int touching_player;
    int rendered;

    fun GObstacle(GPlayer @ gp, int instrument)
    {
        gp @=> player;

        new RayCaster(player) @=> rc;

        // if (shape == c.CYLINDER)
        // {
        //     GCylinder o;
        //     o.color(c.OBSTACLE_COLORS[CYLINDER]);
        //     o @=> obstacle;
        // }
        // else if (shape == )

        GCube cube;
        cube.color(c.OBSTACLE_COLORS[instrument]);
        cube @=> obstacle;
        obstacle.sca(c.PLATFORM_SCALE);
        obstacle.scaY(0.2);
        obstacle --> this;

    }

    fun void color(vec3 c)
    {
        obstacle.color(c);
    }

    fun void update_touching_player()
    {
        // check if the floor is under the player using our raycaster
        rc.under_player(obstacle, this.rotY()) => touching_player;
        if (touching_player) player.set_normal_force(true);      // update this as soon as we detect it!!! prevents clipping through floor
    }

    fun void update(float dt)
    {
        if (rendered)
        {
            update_touching_player();
        }
        
    }
    
}