// ship asset link
// https://sketchfab.com/3d-models/resolution-81fbe06c1e39475aa7c2b27f7e76f4e5

public class GShip extends GGen
{
    GGen @ ship;
    float total_x_rotation;

    0.35 => float ship_speed;

    0.7/3 => float sink_speed;
    0.0005 => float rotate_speed;
    0.0029 => float light_rotate_speed;

    float r_speed;
    float g_speed;
    float b_speed;

    false => int chasing_player;
    false => int chase_over;

    fun GShip()
    {
        load_obj();
    }

    fun void load_obj()
    {
        AssLoader ass_loader;
        ass_loader.loadObj(me.dir() + "obj/ship/Resolution.obj") @=> ship;
        ship --> this;
    }

    fun void begin_chase()
    {
        this.rotateY(-Math.PI/2);
        this.pos(@(0, -120, 0));
        true => chasing_player;
    }

    fun void end_chase()
    {
        false => chasing_player;
        true => chase_over;

        GG.scene().backgroundColor().x / 900 => r_speed;          // 1410 since song is 47 seconds, 30 frames per second
        GG.scene().backgroundColor().y / 900 => g_speed;
        GG.scene().backgroundColor().z / 900 => b_speed;
    }


    fun void update(float dt)
    {
        1 / (dt * 30) => float f;    // frame rate scaling

        if (chasing_player)
        {
            <<< "updating position of ship, current pos:", this.pos() >>>;
            this.pos(this.pos() + @(0, 0, f * -ship_speed));
        }

        if (chase_over)
        {
            if (Math.fabs(total_x_rotation) < Math.PI / 6)
            {
                this.rotateX(f * -rotate_speed);
                total_x_rotation - rotate_speed => total_x_rotation;
                this.pos(this.pos() + @(0, f * -sink_speed, 0));
            }
            else
            {
                this.pos(this.pos() + @(0, f * -sink_speed, 0));
            }


            GG.scene().backgroundColor().x - f*r_speed => float new_r;
            GG.scene().backgroundColor().y - f*g_speed => float new_g;
            GG.scene().backgroundColor().y - f*b_speed => float new_b;
            Math.max(0, new_r) => new_r;
            Math.max(0, new_g) => new_g;
            Math.max(0, new_b) => new_b;
            GG.scene().backgroundColor(@(new_r, new_g, new_b));

            GG.scene().light().rotateX(f*light_rotate_speed);
        }
        // this.rotateOnWorldAxis(@(0, 1, 0), rotate_amount);
    }
}

GShip sh --> GG.scene();
sh.sca(0.1);

while (true)
{
    GG.nextFrame() => now;
}



